﻿/*=================================== © KMK, 2015 =====================================
public function genMaze (_mazeW:Number, _mazeH:Number):Array

_mazeW       - количество столбцов
_mazeH       - количество строк

0 - у ячейки нет ни правой ни нижней стенки    [  ]
1 - у ячейки есть правая стенка, но нет нижней [ |]
2 - у ячейки нет правой стенки, но есть нижняя [__]
3 - у ячейки есть и правая стенка и нижняя     [_|]

  var eller:Eller = new Eller();
  var maze:Array;
  maze = eller.genMaze(5, 4);

=======================================================================================
public function drawMaze (	_container:Sprite, _maze:Array, _scale:Number = 50, _space:Number = 10, 
							_thLine:Number = 9, _thBorder:Number = 9, _thGrid:Number = 1, 
							_colorLine:Number = 0x000000, _colorBorder:Number = 0x000000, _colorGrid:Number = 0xA0A0A0):void

_container   - куда выводить
_maze        - что выводить
_scale       - размер клетки
_space       - отступ от края
_thLine      - толщина линий стенок
_thBorder    - толщина линий границ
_thGrid      - толщина линий сетки
_colorLine   - цвет стенок
_colorBorder - цвет границ
_colorGrid   - цвет сетки

  eller.drawMaze (this, maze, 50, 10, 6, 8, 1, 0xFF0000, 0x00FF00, 0x0000FF);
	
=======================================================================================*/
package
{
	import flash.display.Graphics;
	import flash.display.Sprite;
	
	public class Eller extends Sprite
	{
		private var maze:Array;
		private var much:Array;
		private var temp:Array;
		
		private var mazeWidth:Number;
		private var mazeHeight:Number;
		
		public function Eller ():void
		{
			// конструктор
		}
		
		//=======================================================================================
		public function genMaze (_mazeW:Number, _mazeH:Number):Array
		{
			mazeWidth = _mazeW;
			mazeHeight = _mazeH;

			var _i:Number;
			var _j:Number;
			
			maze = new Array ();
			much = new Array ();
			temp = new Array ();
			
			for (_i = 0; _i < mazeHeight; _i++)
			{
				maze[_i] = new Array (mazeWidth);
				for (_j = 0; _j < mazeWidth; _j++)
				{
					maze[_i][_j] = 0;
				}
			}
			for (_i = 0; _i < mazeWidth; _i++)
			{
				much [_i] = 0;
				temp [_i] = 0;
			}
			
			step1 (0);
			step2 (0);
			for (_i = 1; _i < mazeHeight - 1; _i++)
			{
				step3 (_i);
				step1 (_i);
				step2 (_i);
			}
			step3 (mazeHeight - 1);
			step1 (mazeHeight - 1);
			step4 (mazeHeight - 1);
			
			return maze;
			
			maze = null;
			much = null;
			temp = null;
		}
		
		private function step1 (_curRow:Number):void
		{
			var _i:Number;
			var _j:Number;
			var _k:Number;
			var _checker:Boolean = false;
			
			for (_i = 0; _i < mazeWidth; _i++)
			{
				if (much[_i] == 0)
				{
					for (_k = mazeWidth; _k > 0; _k--)
					{
						for (_j = 0; _j < mazeWidth; _j++)
						{
							if (much[_j] != _k)
							{_checker = false}
							else
							{_checker = true;
							break;
							}
						}
						if (_checker == false)
						{
							much[_i] = _k;
						}
					}
				}
			}
			temp = much.concat ();
			for (_i = 0; _i < mazeWidth - 1; _i++)
			{
				if (randomize () == 1)
				{
					maze[_curRow][_i] = 1;
				}
				else
				{
					if (much [_i+1] == temp [_i])
					{
						much [_i+1] = much [_i];
						maze[_curRow][_i] = 1;
					}
					if (much [_i+1] == much [_i])
					{
						maze[_curRow][_i] = 1;
					}
					else
					{
						if (_curRow != mazeHeight - 1)
						{
						much [_i+1] = much [_i];
						}
					}
				}
			}
		}
		
		private function step2 (_curRow:Number):void 
		{
			var _i:Number;
			var _j:Number;
			var _k:Number;
			var _checker:Boolean = false;

			for (_i = 0; _i < mazeWidth; _i++)
			{
				for (_j = _i + 1; _j < mazeWidth; _j++)
				{
					if (much [_i] == much [_j])
					{
						_checker = true;
						break;
					}
					else 
					{
						_checker = false;
					}
				}
				for (_k = 0; _k < _i; _k++)
				{
					if ((much [_k] == much [_i])&&((maze[_curRow][_k] == 0)||(maze[_curRow][_k] == 1)))
					{
						_checker = true;
						break;
					}
					else
					{
						_checker = false;
					}
				}
				if ((randomize () == 1)&&(_checker == true))
				{
					if (_i == mazeWidth) {maze[0][_i] = 2}
					else
					if (maze[_curRow][_i] == 1) {maze[_curRow][_i] = 3}
					else {maze[_curRow][_i] = 2}
				}
			}
		}
		
		private function step3 (_curRow:Number):void
		{
			var _i:Number;

			for (_i = 0; _i < mazeWidth; _i++)
			{
				maze[_curRow][_i] = maze[_curRow - 1][_i]; 
			}
			for (_i = 0; _i < mazeWidth; _i++)
			{
				if (maze[_curRow][_i] == 1)
				{
					maze[_curRow][_i] = 0;
				}
				else if (maze[_curRow][_i] == 3)
				{
					maze[_curRow][_i] = 2;
				}
			}
			for (_i = 0; _i < mazeWidth; _i++)
			{
				if ((maze[_curRow][_i] == 2)||(maze[_curRow][_i] == 3))
				{
					much [_i] = 0;
				}
			}
			for (_i = 0; _i < mazeWidth; _i++)
			{
				maze[_curRow][_i] = 0; 
			}
		}
		
		private function step4 (_curRow:Number):void
		{
			var _i:Number;
			
			for (_i = 0; _i < mazeWidth - 1; _i++)
			{
				if (much [_i+1] != much [_i])
				{
					maze[_curRow][_i] = 0;
				}
			}
		}
		
		private function randomize ():Number
		{
			return Math.floor (Math.random () * 2);
		}
		
		//=======================================================================================
		public function drawMaze (_container:Sprite, _maze:Array, _scale:Number = 50, _space:Number = 10, 
								  _thLine:Number = 9, _thBorder:Number = 9, _thGrid:Number = 1,
								  _colorLine:Number = 0x000000, _colorBorder:Number = 0x000000, _colorGrid:Number = 0xA0A0A0):void
		{
			var _mazeSprite:Sprite = new Sprite ();
			var _col:Number = _maze[0].length;
			var _row:Number = _maze.length;
			
			while (_container.numChildren > 0)
			{
				_container.removeChildAt (0);
			}
		
			_mazeSprite.graphics.lineStyle (_thGrid, _colorGrid);
			
			for (var _i:Number = 0; _i < _col; _i++)
			{
				_mazeSprite.graphics.moveTo((_i*_scale)+_space, _space); 
				_mazeSprite.graphics.lineTo((_i*_scale)+_space, (_row*_scale)+_space); 
			}
			for (_i = 0; _i < _row; _i++)
			{
				_mazeSprite.graphics.moveTo(_space, (_i*_scale)+_space); 
				_mazeSprite.graphics.lineTo((_col*_scale)+_space, (_i*_scale)+_space); 
			}
			for (_i = 0; _i < _row; _i++)
			{
				for (var _j:Number = 0; _j < _col; _j++)
				{
					drawCell (_mazeSprite, _maze[_i][_j], _j, _i, _scale, _space, _thLine, _colorLine, _colorGrid, _colorBorder);
				}
			}
			
			_mazeSprite.graphics.lineStyle (_thBorder, _colorBorder); 
			_mazeSprite.graphics.drawRect (_space, _space, _col*_scale, _row*_scale); 
			
			_mazeSprite.x = 0
			_mazeSprite.y = 0
			
			_container.addChild (_mazeSprite);
			_mazeSprite = null ;
		}

		private function drawCell (_spr:Sprite, _dir:Number, _numX:Number, _numY:Number, _scale:Number, _space:Number, _thLine:Number, _colorLine:Number, _colorGrid:Number, _colorBorder:Number):void
		{
			_spr.graphics.lineStyle (_thLine, _colorLine);
			switch (_dir)
			{
				case 1 :
				_spr.graphics.moveTo((_numX*_scale)+_space+_scale, (_numY*_scale)+_space+_scale); 
				_spr.graphics.lineTo((_numX*_scale)+_space+_scale, (_numY*_scale)+_space); 
				break;
				case 2 :
				_spr.graphics.moveTo((_numX*_scale)+_space, (_numY*_scale)+_space+_scale); 
				_spr.graphics.lineTo((_numX*_scale)+_space+_scale, (_numY*_scale)+_space+_scale); 
				break;
				case 3 :
				_spr.graphics.moveTo((_numX*_scale)+_space+_scale, (_numY*_scale)+_space+_scale); 
				_spr.graphics.lineTo((_numX*_scale)+_space+_scale, (_numY*_scale)+_space); 
				_spr.graphics.moveTo((_numX*_scale)+_space, (_numY*_scale)+_space+_scale); 
				_spr.graphics.lineTo((_numX*_scale)+_space+_scale, (_numY*_scale)+_space+_scale); 
				break;
			}
		}
		//=======================================================================================
	}
}